Bugzilla will be upgraded to version 5.0 on a still to be determined date in the near future. The original upgrade date has been delayed.
Bug 1485283 - There is a reachable assertion abort in function calcstepsizes() of JasPer that will lead to remote denial of service attack.
There is a reachable assertion abort in function calcstepsizes() of JasPer th...
Status: NEW
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: jasper (Show other bugs)
7.5-Alt
Unspecified Unspecified
unspecified Severity unspecified
: rc
: ---
Assigned To: Josef Ridky
Desktop QE
: Security
Depends On:
Blocks: CVE-2017-13751
  Show dependency treegraph
 
Reported: 2017-08-25 05:23 EDT by owl337
Modified: 2018-08-01 19:32 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Triggered by " ./imginfo -f POC6" (331 bytes, application/x-rar)
2017-08-25 05:23 EDT, owl337
no flags Details

  None (edit)
Description owl337 2017-08-25 05:23:51 EDT
Created attachment 1318069 [details]
Triggered by  " ./imginfo -f POC6"

Description of problem:

There is a reachable assertion abort in function calcstepsizes() of JasPer that will lead to remote denial of service attack.

Version-Release number of selected component (if applicable):

<= latest version

How reproducible:

 ./imginfo -f POC6

Steps to Reproduce:

The output information is as follows:

$ ./imginfo -f POC6
warning: trailing garbage in marker segment (14 bytes)
warning: trailing garbage in marker segment (2 bytes)
warning: trailing garbage in marker segment (14 bytes)
warning: trailing garbage in marker segment (14 bytes)
warning: trailing garbage in marker segment (14 bytes)
warning: trailing garbage in marker segment (11 bytes)
warning: trailing garbage in marker segment (14 bytes)
imginfo: /home/icy/secreal/jasper/src/libjasper/jpc/jpc_dec.c:1703: void calcstepsizes(uint_fast16_t, int, uint_fast16_t *): Assertion `!((expn + (numrlvls - 1) - (numrlvls - 1 - ((bandno > 0) ? ((bandno + 2) / 3) : (0)))) & (~0x1f))' failed.
Aborted (core dumped)


The gdb debugging information is listed below:
(gdb) set args POC6
(gdb) r 
The program being debugged has been started already.
Start it from the beginning? (y or n) y
Starting program: /home/icy/secreal/jasper/install/bin/imginfo -f fuzz/output/crashes/id:000072,sig:06,src:001342,op:flip2,pos:238
warning: trailing garbage in marker segment (14 bytes)
warning: trailing garbage in marker segment (2 bytes)
warning: trailing garbage in marker segment (14 bytes)
warning: trailing garbage in marker segment (14 bytes)
warning: trailing garbage in marker segment (14 bytes)
warning: trailing garbage in marker segment (11 bytes)
warning: trailing garbage in marker segment (14 bytes)
imginfo: /home/icy/secreal/jasper/src/libjasper/jpc/jpc_dec.c:1703: void calcstepsizes(uint_fast16_t, int, uint_fast16_t *): Assertion `!((expn + (numrlvls - 1) - (numrlvls - 1 - ((bandno > 0) ? ((bandno + 2) / 3) : (0)))) & (~0x1f))' failed.

Program received signal SIGABRT, Aborted.
0x00007ffff71f8428 in __GI_raise (sig=sig@entry=6) at ../sysdeps/unix/sysv/linux/raise.c:54
54	../sysdeps/unix/sysv/linux/raise.c: No such file or directory.
(gdb) bt 
#0  0x00007ffff71f8428 in __GI_raise (sig=sig@entry=6) at ../sysdeps/unix/sysv/linux/raise.c:54
#1  0x00007ffff71fa02a in __GI_abort () at abort.c:89
#2  0x00007ffff71f0bd7 in __assert_fail_base (fmt=<optimized out>, 
    assertion=assertion@entry=0x7ffff7bc04d0 "!((expn + (numrlvls - 1) - (numrlvls - 1 - ((bandno > 0) ? ((bandno + 2) / 3) : (0)))) & (~0x1f))", 
    file=file@entry=0x7ffff7bc02f0 "/home/icy/secreal/jasper/src/libjasper/jpc/jpc_dec.c", 
    line=line@entry=1703, 
    function=function@entry=0x7ffff7bc0498 "void calcstepsizes(uint_fast16_t, int, uint_fast16_t *)")
    at assert.c:92
#3  0x00007ffff71f0c82 in __GI___assert_fail (
    assertion=0x7ffff7bc04d0 "!((expn + (numrlvls - 1) - (numrlvls - 1 - ((bandno > 0) ? ((bandno + 2) / 3) : (0)))) & (~0x1f))", file=0x7ffff7bc02f0 "/home/icy/secreal/jasper/src/libjasper/jpc/jpc_dec.c", line=1703, 
    function=0x7ffff7bc0498 "void calcstepsizes(uint_fast16_t, int, uint_fast16_t *)") at assert.c:101
#4  0x00007ffff7b45665 in calcstepsizes (refstepsize=<optimized out>, numrlvls=<optimized out>, 
    stepsizes=<optimized out>) at /home/icy/secreal/jasper/src/libjasper/jpc/jpc_dec.c:1702
#5  jpc_dec_cp_prepare (cp=<optimized out>) at /home/icy/secreal/jasper/src/libjasper/jpc/jpc_dec.c:1721
#6  jpc_dec_process_sod (dec=<optimized out>, ms=<optimized out>)
    at /home/icy/secreal/jasper/src/libjasper/jpc/jpc_dec.c:592
#7  0x00007ffff7b49ceb in jpc_dec_decode (dec=<optimized out>)
    at /home/icy/secreal/jasper/src/libjasper/jpc/jpc_dec.c:424
---Type <return> to continue, or q <return> to quit---
#8  jpc_decode (in=<optimized out>, optstr=<optimized out>)
    at /home/icy/secreal/jasper/src/libjasper/jpc/jpc_dec.c:261
#9  0x00007ffff7b2d030 in jp2_decode (in=<optimized out>, optstr=<optimized out>)
    at /home/icy/secreal/jasper/src/libjasper/jp2/jp2_dec.c:218
#10 0x00007ffff7b059ce in jas_image_decode (in=<optimized out>, fmt=<optimized out>, optstr=<optimized out>)
    at /home/icy/secreal/jasper/src/libjasper/base/jas_image.c:442
#11 0x0000000000401bab in main (argc=<optimized out>, argv=<optimized out>)
    at /home/icy/secreal/jasper/src/appl/imginfo.c:238


Trigged in:
Breakpoint 8, calcstepsizes (refstepsize=<optimized out>, numrlvls=24, stepsizes=<optimized out>)
    at /home/icy/secreal/jasper/src/libjasper/jpc/jpc_dec.c:1702
1697		expn = JPC_QCX_GETEXPN(refstepsize);
1698		mant = JPC_QCX_GETMANT(refstepsize);
1699		numbands = 3 * numrlvls - 2;
1700		for (bandno = 0; bandno < numbands; ++bandno) {
1701	//jas_eprintf("DEBUG %d %d %d %d %d\n", bandno, expn, numrlvls, bandno, ((numrlvls - 1) - (numrlvls - 1 - ((bandno > 0) ? ((bandno + 2) / 3) : (0)))));
1702			stepsizes[bandno] = JPC_QCX_MANT(mant) | JPC_QCX_EXPN(expn +
1703			  (numrlvls - 1) - (numrlvls - 1 - ((bandno > 0) ? ((bandno + 2) / 3) : (0))));
1704		}
1705	}
1706	
(gdb) n
1700		for (bandno = 0; bandno < numbands; ++bandno) {


Actual results:

crash

Expected results:

crash

Additional info:

Credits:

This vulnerability is detected by team OWL337, with our custom fuzzer collAFL. Please contact ganshuitao@gmail.com   and chaoz@tsinghua.edu.cn if you need more info about the team, the tool or the vulnerability.
Comment 2 Josef Ridky 2017-08-25 06:37:25 EDT
Thank you for taking the time to report this issue to us. We appreciate the feedback and use reports such as this one to guide our efforts at improving our products. That being said, this bug tracking system is not a mechanism for requesting support, and we are not able to guarantee the timeliness or suitability of a resolution.

If this issue is critical or in any way time sensitive, please raise a ticket through the regular Red Hat support channels to ensure it receives the proper attention and prioritization to assure a timely resolution. 

For information on how to contact the Red Hat production support team, please visit:
    https://www.redhat.com/support/process/production/#howto

For proper identification of issue are required properly filled following information:

- Description of problem
- Version-Release number of selected component (if applicable)
- Steps to Reproduce
- Actual results
- Expected results
- Additional info
Comment 3 Tomas Hoger 2017-09-20 17:39:59 EDT
The assertion failure in calcstepsizes() was previously reported as CVE-2016-9399 (bug 1396981) and is tracked upstream via this issue report:

https://github.com/mdadams/jasper/issues/83

Code paths leading to the assertion using your test case and the one in the report for CVE-2016-9399 are mostly the same.  Can you provide reasoning why the new CVE is required / justified here?  If you agree this is a dupe of the earlier CVE, please get the new CVE rejected as duplicate (similar to CVE-2017-13753).
Comment 4 owl337 2017-11-13 07:17:07 EST
Did you make sure the two trigger paths exactly the same?

Note You need to log in before you can comment on or make changes to this bug.